/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import net.designnation.events.*;

class Code.Ents.Drop extends EventSource
{
	private var timeline	: MovieClip;
	private var moving_mc	: MovieClip;
		
	private var dropId	: String;
	private var clickFlag	: Boolean;
	
	
	public function Drop( timelineRef: MovieClip, id: String )
	{
		this.timeline = timelineRef;
		this.dropId = id;
		this.clickFlag = true;
	}
	
	public function initDrop( args: Object )
	{
		this.moving_mc = timeline.attachMovie( "dropClip", "movingMC", timeline.getNextHighestDepth( ),
						{ _x: args.posIni.x, _y: args.posIni.y }
						 );
		
		
		var parentClass: Drop = this;
		this.moving_mc.onRelease = function( )
		{
			parentClass.clickReleased( );
		};
	}
	
	public function destroy( )
	{
		this.moving_mc.removeMovieClip( );
		
		delete this;
	}
	
	private function clickReleased( )
	{
		if ( this.clickFlag )
		{
			fireEvent( "onDropClicked" , { dropId: this.dropId } );		
		}

	}
	
	public function notClickeable( )
	{
		this.clickFlag = false;
	}
	

}