import net.designnation.behaviours.*
import net.designnation.data.*

class net.designnation.behaviours.State
{
		public static var STATE_TAG			: String= "state";
		private static var CALLBACK_TAG		: String= "callbackObject";
		private static var TRANSITIONS_TAG	: String= "transitions";
		private static var DELAY_VALUE_TAG	: String= "delayValue";

		
		public static var DELAY_VAR_NAME		: String= "__stateDelayValue__";
		public static var DEFAULT_DELAY_VAR_NAME: String= "__stateDefaultDelayValue__";
		
		private var transitions: Array;
		//private var propertiesVal: fgCommDTO;
		
		private var actionCallbackVal: CallbackDecl;
		private var idVal: String;
		
		private var referencesMap: HashMap;
		
		public var __traceInfo__: Boolean= false;
		
		public function State( idParam: String, actionCallback: CallbackDecl )
		{			
			this.id			 	  = idParam;
			this.transitions	  = new Array(  );			
			this.actionCallbackVal= actionCallback;
		}
		
		public function set id( idParam: String )
		{
			this.idVal= idParam;
		}
		
		public function get id(  ): String
		{
			return this.idVal;
		}
		
		public function set actionCallback( actionClbck: CallbackDecl )
		{
			this.actionCallbackVal= actionClbck;
		}
		
		
		public function addTransition( transition: Transition )
		{
			if( transitionDoNotExist( transition ) )
			{
				this.transitions.push( transition );			
			}
		}
		
		private function transitionDoNotExist( transition: Transition )
		{
			var tam: Number= this.transitions.length;

			var bExists: Boolean= false;
						
			for( var ix: Number= 0; ix< tam && !bExists; ix++ )
			{
				bExists= this.transitions[ ix ].id== transition.id;
			}
			return !bExists;
		}
		
		public function getTransitions( Void ): Array
		{
			return this.transitions;
		}
		
		public function evalState( paramater: Object ): Pair
		{
			var nextState: State= undefined;
			var retPair: Pair;
			
			var nTam: Number= this.transitions.length;
			
			for( var nIx: Number= 0; nIx< nTam && nextState== undefined; nIx++ )
			{
				var currentTransition: Transition= this.transitions[ nIx ];
				
				if( currentTransition.evaluate(  ) )
				{
					if( this.__traceInfo__ )
					{	
						trace( "TRANSIT:"+ this.id+ "->"+ currentTransition.endState.id+ " BY "+ currentTransition.id );
					}				
			
					nextState= currentTransition.endState;				
					retPair	 = new Pair( nextState, currentTransition );	
				}
			}			
			return retPair;
		}
		
		public function execute( parameter: Object ): Object
		{		
			if( this.__traceInfo__ )
			{
				trace( "S[A]:"+ this.id+"; "+ this.actionCallbackVal.callbackMethod );
			}				
			
			return actionCallbackVal.fire( parameter );
		}	
		
		// fgIXMLSerializable
		
		public function toString( Void ): String
		{
			var str = "State :{\n";
			str+= "id " + this.id+ "\n";
			str+= "}";
			return str;			
		}		
		
}