/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import net.designnation.data.*

class net.designnation.data.HashMapIteratorImpl extends HashMap implements IIterator
{
	private var targetHashMapVal: HashMap;
	private var disperseTableIx: Number= -1;
	private var listIterator: IIterator= undefined;
	
	public function HashMapIteratorImpl( targetHashMap: HashMap )
	{
		super.HashMap(  );
		
		this.targetHashMapVal= targetHashMap;		
	}
	
	public function hasNext(  ): Boolean
	{
		return getNext( false )!= undefined;
	}
	
	public function next(  ): Object
	{		
		var node: Pair= Pair( getNext( true ) );
		var retVal: Object= undefined;
		
		if( node!= undefined )
		{
			retVal= node;
		}
		
		return retVal;
	}
		
	public function remove(  )
	{
	}
	
	private function getNext( setValues: Boolean ): Object
	{
		var disperseTableIxAux: Number  	= this.disperseTableIx;		
		var retVal			  : Object		= undefined;
		var arrDispTable	  : Array		= this.targetHashMapVal.getDisperseTable(  );
		var itAux			  : IIterator	= this.listIterator;
		var searchOn		  : Boolean		= true;
		
		while( searchOn )
		{
			if( this.listIterator== undefined || !this.listIterator.hasNext(  ) )
			{
				disperseTableIxAux++;
				
				searchOn= disperseTableIxAux>= 0 && 
					disperseTableIxAux< arrDispTable.length;
					
				while( searchOn )
				{										
					var listElement: ListOfPairs= arrDispTable[ disperseTableIxAux ];
					
					if( listElement!= undefined )
					{
						itAux= listElement.iterator(  );				
						break;
					}
					else
					{
						disperseTableIxAux++;
					}
					
					searchOn= disperseTableIxAux>= 0 && 
						disperseTableIxAux< arrDispTable.length;
				}			
			}		
			
			if( searchOn )
			{
				if( setValues )
				{
					this.disperseTableIx= disperseTableIxAux;		
					this.listIterator	= itAux;
					retVal				= this.listIterator.next(  );				
				}
				else if( itAux.hasNext(  ) )
				{
					retVal= 0;
				}		
				searchOn= retVal== undefined;		
			}
		}
		
		return retVal;
	}
}