/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import net.designnation.events.*
import net.designnation.data.*

class net.designnation.events.EventSource implements IEventRegister
{
	private var iEventRegisterImpl: IEventRegisterImpl;
	private var idVal: Object;
	private var objectKeyVal: Number;
	
	public static var OBJECT_KEY_SEQUENCE: Number= 0;
	
	public var __traceInfo__: Boolean= false;
	
	public function EventSource(  )
	{
		this.objectKeyVal= OBJECT_KEY_SEQUENCE++;
	}
	
	public function get objectKey(  )
	{
		return this.objectKeyVal;
	}
	
	public function set id( idParam: Object )
	{
		this.idVal= idParam;
	}
	
	public function get id(  ): Object
	{
		return this.idVal;
	}
				
	public function registerEvent( obj: Object, eventName: String, eventCallbackName: String ): Boolean
	{
		if( iEventRegisterImpl== undefined )
		{
			iEventRegisterImpl= new IEventRegisterImpl(  );
			iEventRegisterImpl.__traceInfo__= this.__traceInfo__;
		}
		
		return iEventRegisterImpl.registerEvent( obj, eventName, eventCallbackName );
	}
	
	public function unregisterEvent( obj: Object, eventName: String ): Boolean
	{
		return iEventRegisterImpl.unregisterEvent( obj, eventName );
	}
	
	public function fireEvent( eventName: String, arg: Object ): HashMap
	{
		return iEventRegisterImpl.fireEvent( eventName, arg );
	}	
	
	public function clearRegisteredEvents(  )
	{
		return iEventRegisterImpl.clearRegisteredEvents(  );
	}
}

